import re

physical_quantity_dict = {
"长度": ["刻度尺", "米", "光年", "身高", "[长厚]度", "[厘分千]米"],
"距离": ["距离", "相距"],
"高度": ["高度", "高"],
"时间": ["时间", "秒", "分钟", "秒表"],
"质量": ["质量", "千克", "克", "惯性", "天平", "公?斤", "\dk?g"],
"密度": ["密度", "鉴别", "g/cm\^?3", "kg/m\^?3"],
"速度": ["速度", "米每秒", "平均速度", "运动图像", "追及", "相遇", "m/s", "km/h"],
"重力": ["重力", "重心", "纬度"],
"弹力": ["形变", "弹力", "胡克", "弹簧"],
"拉力": ["拉力", "拉伸"],
"摩擦力": ["摩擦力", "静摩擦", "滑动摩擦", "滚动摩擦", "接触面粗糙程度", "摩擦"],
"压强": ["压强", "压力效果"],
"液体压强": ["液体压强", "连通器"],
"大气压强": ["大气压", "流体压强", "托里拆利实验"],
"浮力": ["浮力", "漂浮", "沉浮", "悬浮", "阿基米德原理"],
# (?!快)排除"快"
"功": ["做功(?!快)", "功(?!快)"],
"功率": ["功率", "做功快慢", "瓦特"],
"动能": ["动能"],
"重力势能": ["重力势能", "重力做功"],
"弹性势能": ["弹性势能"],
"机械能": ["机械能", "动能", "势能"],
"海拔高度": ["海拔", "海拔高度"],
"横截面积": ["横截面积", "底面积"],
"阻力臂": ["阻力臂", "杠杆"],
"动力臂": ["动力臂", "杠杆"],
"电荷": ["静电", "摩擦起电", "正电荷", "负电荷", "元电荷", "电荷", "验电器", "带电"],
"电流": ["定向移动", "安培", "电流", "电流热效应", "电流磁效应", "电流表", "安培表", "电笔"],
"电压": ["电压", "电压表", "伏特"],
"电阻": ["电阻", "电阻器", "电阻率", "欧姆", "半导体", "超导", "变阻器", "欧姆定律", "Ω"],
"电功": ["电功", "焦耳定律", "电能"],
"电功率": ["额定功率", "电功率", "电功快慢", "额定电压"],
"温度": ["温度", "温度计", "摄氏度", "华氏度", "温标", "保温", "体温计", "寒暑表", "℃"],
"内能": ["分子动理论", "热运动", "分子间作用力", "热传递"],
"热量": ["热量", "热值"],
"比热容": ["比热容", "吸热本领", "J/(kg·℃)"],
"音调": ["音调", "频率", "高音", "低音", "Hz"],
"响度": ["振幅", "分贝", "响度", "dB"],
"音色": ["乐器", "音色", "闻其声知其人"],
"入射角": ["入射", "入射角度"],
"反射角": ["反射", "反射角度"],
"光速": ["光速"],
"像距": ["像距"],
"物距": ["物距"],
}

def physical_quantity_extract(content):
    physical_quantity = []
    for k,v in physical_quantity_dict.items():
        if re.findall('|'.join(v), content):
            physical_quantity.append(k)
    
    return physical_quantity


if __name__ == "__main__":
    content = "如图,在老师的指导下,小军用测电笔(试电笔)试触某插座的插孔,用指尖抵住笔尾金属体,测电笔的氖管发光,此时(选填'有'或'没有')电流通过小军的身体,"
    res = physical_quantity_extract(content)
    print(res)